<?php
require_once('buffered_system.php');

/* Generate core html from eqtext (ordinary text containing (La)TeX
 * math environments
 */
function eqtext2html($source, &$log) {
  $display = '/\$\$[^\$]*\$\$/U';
  $inline  = '/\$[^\$]*\$/U';
  $images = array();
  foreach ( array('display', 'inline') as $mode ) {
    preg_match_all($$mode, $source, $matches, PREG_PATTERN_ORDER);
    foreach ( $matches[0] as $eq ) {
      $img->eq   = $eq;
      $img->name = eqtext2html_imgname($eq);
      $log .= buffered_system("./latex2img /var/www/LaTeXEq/equation_cache/{$img->name}", $img->errorcode, $eq);
      $images[] = $img;
    }
    foreach ( $images as $img ) {
      $source = str_replace($img->eq, 
			    ($mode=='display'?'<p class="dmath">':'').
			    "<img src=\"equation_cache/{$img->name}\" alt=\"".str_replace('$','',$img->eq)."\">".
			    ($mode=='display'?'</p>':''), 
			    $source);
    }
  }

  // Other possible formatting
  array('/\n{2,}([^\n]+[^\.\?\!\,\;\n])\n{2,}/', // Heading
	'/\n{2,}/'); // Next paragraph
  return $source;
}

function eqtext2html_imgname($source) {
  return 'eq_'.dechex(crc32($source)).'.png';
}
?>
