<?php
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is TopicTree code.
 *
 * The Initial Developer of the Original Code is Miika Nurminen.
 * Portions created by Miika Nurminen are Copyright
 * (C) Miika Nurminen. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

require('generic.php');
require('tree.php');
require('doctree_global.php');
require_once('htmllib.php');
detectDOM();
XMLheader();
doctype("1.0 transitional");

// initialize global variables
$all = "";
$update = 0;
$link="";

if (sizeof($HTTP_GET_VARS)) {
  if (arrayKeyExists('all',$HTTP_GET_VARS)) $all=$HTTP_GET_VARS['all'];
  if (arrayKeyExists('update',$HTTP_GET_VARS)) $update=$HTTP_GET_VARS['update'];
  if (arrayKeyExists('link',$HTTP_GET_VARS)) $link=$HTTP_GET_VARS['link'];
}

function persistent_http_variables() {
  global $all;
  return "all=".$all;
}

?>
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fi" >
<head>
<title>Bookmarks</title>
<link rel="stylesheet" href="treestyles.css" type="text/css"></link>
<? if ($all!="true") DOMstyles(true); ?>
<?php include('keyboard.js'); // script src does not work... ?>

<script type="text/javascript">
    function RefreshClick (name) {
      window.location="<? echo SelfDoc()?>?"+name;
    }

    function open_url(name) {
	window.open(name);
    }

    function combine_str(a,b,c) {
        return (a+b+c);
    }

    function open_combined_url(a,b,c) {
        open_url(a+b+c);
    }

    function test_key(event,a,b,c) {
	code=event.keyCode; // for IE
	if (code==0) code=event.which; // for NS
	if (code==13) 
		open_url(a+b+c)    
    }
</script>

<?

function insert_anchor($actname) {
    echo "<a id=\"".$actname."\"></a>\n";
}

function suffix_substr($str,$len,$suffix) {
  if (strlen($str)<$len) return $str;
  return substr($str,0,$len).$suffix;
}

function insert_link($docdata) {
    echo "<li class=\"basic\"> ".$docdata[0];
    if (trimlen($docdata[1])>0) {
        echo " - <span class=\"links\">[&nbsp;";
        for ($i=1; $i<count($docdata); $i++) {
            if ($i>1) echo " -&nbsp;";
            echo "<a target=\"_blank\" href=\"".$docdata[$i]."\">".suffix_substr(strip_html($docdata[$i]),80,"...")."</a>";
        }
        echo "&nbsp;]</span>";
    }
    echo "</li>\n";
}

function insert_popup($docdata) {
    echo "<li class=\"basic\"> ".$docdata[1]."";
    if (trimlen($docdata[2])>0) {
        echo " - <span class=\"links\">[ ";
?>
<?

        echo "<a target=\"_blank\" 
href=\"".$docdata[2]."\">".strip_html($docdata[2])."</a>";
        echo " ]</span>"; 
?>
<div>
<input type="text" id="button_<?echo $docdata[1];?>" value="" 
onkeypress="test_key(event,'<?echo 
$docdata[3]."',this.value,'".trim($docdata[4])?>')"></input>
<button onclick="open_combined_url('<?echo $docdata[3]."',document.getElementById('button_".$docdata[1]."').value,'".trim($docdata[4])?>')">Go</button>
</div>
<?
    }
    echo "</li>\n";
}


function insertfile($actname,$expand) {
  global $link,$update,$DOM,$all;
   
   $external = false;
   $urlpath = "";
   // allows shared links!
   if (strpos($actname,"http://")===false) {
    $name=docdir().$actname;
   }
   else {
    $name=$actname;
    $external = true;
    $urlpath = url_strip_filename($name);
   }

  if (($link==$actname) && ($update==2)) {


    insert_anchor($actname);
?>
<form action="refresh.php?<? echo "&amp;".persistent_http_variables()."&amp;link=$link\"" ?> method="post">
<? 
    if ($all!="") { 
?>
<input type="hidden" name="all" value="true" />
<? 
    } 
?>
<?
    $fp=fopen(docdir().$link,"r");
    if ($fp!=FALSE) {
      $fline=fgets($fp,400);
      $content = "";
      while(!feof($fp)) { $content .= fgets($fp,400); }
      fclose($fp);
    }
?>

<?= textfield("headline",$fline) ?>
<br />
<?= textarea("area",5,90,$content) ?>

<br />
<input type="submit" value="Update" />
<input type="reset" />
<a href="index.php?<? echo persistent_http_variables()."&".link_anchor("link",$actname); ?>"><input type="button" value="Cancel" onClick="RefreshClick('<? echo persistent_http_variables()."&".link_anchor("link",$actname); ?>')"</a>
<!-- refreshclick is for ie 5.5 -->
</form>
<?
  }
  else {
    if ( (!$external) && (!file_exists($name))) {
      $op = fopen($name,"w");
      fwrite($op,"New Topic");
      fclose($op);
      chmod($name,0666);
    }
    $fp = fopen($name,"r");
    if (!$fp) exit;
    $fline=fgets($fp,400);
    if (($expand) || (!$DOM) || (strcmp($link,$actname)==0)) echo "<li class=\"col\">";
    else echo "<li class=\"exp\">";  
    insert_anchor($actname);
    if (!$external) {
                           // linkupdate.php
      echo "\n<b>".$fline."</b> [ <a href=\"index.php?".persistent_http_variables()."&amp;update=2&amp;link=$actname#$actname\">".$actname."</a> ]\n<ul class=\"";
    }
    else {
      echo "\n<b>".$fline."</b> [ $actname ]\n<ul class=\"";
    }
    if (($expand) || (!$DOM) || (strcmp($link,$actname)==0)) echo "subexp"; else echo "sub";
    echo "\">";
    while (!feof($fp)) {
       $fline=fgets($fp,400);
     if (strlen($fline)<2) break;
      $docdata=explode("|",$fline);
      if ((count($docdata)>1) && ($docdata[0]=="POPUP")) insert_popup($docdata);
      else if (count($docdata)>1) insert_link($docdata);
      else if (count($docdata)>0) {
        $filename = trim($docdata[0]); 
        if ($external) $filename= $urlpath.$filename;
	insertfile($filename,false);
        echo "</ul></li>";
      }
    }
  }
} 
?>        

<? enableTree(); 
if ($update==2) { // supress key event to get reliable text field editing
?>
<script language="JavaScript" type="text/javascript">
document.onkeypress = null;
document.onkeyup = null;


// code from : http://tuckey.org/textareasizer/
function countLines(strtocount, cols) {
    var hard_lines = 1;
    var last = 0;
    while ( true ) {
        last = strtocount.indexOf("\n", last+1);
        hard_lines ++;
        if ( last == -1 ) break;
    }
    var soft_lines = Math.round(strtocount.length / (cols-1));
    var hard = eval("hard_lines  " + unescape("%3e") + "soft_lines;");
    if ( hard ) soft_lines = hard_lines;
    if (soft_lines>25) soft_lines=25;
    return soft_lines;
}

function cleanForm(evt) {
    var the_form = document.forms[0];
    for ( var x in the_form ) {
        if ( ! the_form[x] ) continue;
        if( typeof the_form[x].rows != "number" ) continue;
        the_form[x].rows = countLines(the_form[x].value,the_form[x].cols) 
+1;
    }
    setTimeout("cleanForm();", 300);
}
// -->
</script>
<?
}
?>
</head>
<?php if ($update==2) { ?>
<body onload="cleanForm();">
<?php 
  } else { 
?>
<body>
<?php
  } 

$urlend = "&link=".$link."&update=".$update."#".$link;

?>
<div class="basetext">

&nbsp;<? if ($all!="true") { ?>
<?expandButtons("base");?> 
<a href="index.php?all=true<?=$urlend ?>">Show all</a>
<? } else {?>
<a href="index.php?<?=$urlend ?>">Normal</a>
<? } ?>
</div>

<div id="base" class="basetext">
<ul class="subexp">
<? insertfile(rootdoc(),true); ?>
</ul>
</div>

<div class="basetext">

&nbsp;<? if ($all!="true") { ?>
<?expandButtons("base");?> 
<a href="index.php?all=true<?=$urlend ?>">Show all</a>
<? } else {?>
<a href="index.php?<?=$urlend ?>">Normal</a>
<? } ?>
<? if ($link!="") { ?>
<script language="JavaScript" type="text/javascript">
getVisibleParents('<?=$link ?>');
</script>
<? } ?>
</div>
</body>
</html>

