/*
 * GxlLib.java
 *
 * Copyright (C) 2003 Miika Nurminen
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
import java.util.Map;
import java.util.HashMap;
import org.w3c.dom.*;

/**
 * Simple GXL Framework.
 *
 * @version 0.1 - 2003-8-7
 * @author  minurmin
 */
public class GxlLib {
  
  /** Creates a new instance of GxlLib */
  public GxlLib() {
  }
  
  /**
   * Note! Tuple attributes are not supported.
   */
  public static Map getNodeAttributes(Node n) {
    NodeList nl = n.getChildNodes();
    Map result = new HashMap();
    for (int i=0; i<nl.getLength(); i++) {
      if (!(nl.item(i) instanceof Element)) continue;
      Element e = (Element)(nl.item(i));
      if (!e.getNodeName().equals("attr")) continue;
      String key = e.getAttribute("name");
      String value="";
      NodeList inner = e.getChildNodes();
      for (int j=0; j<inner.getLength(); j++) {
        if (inner.item(j) instanceof Element) {
          Element attr = (Element)(inner.item(j));
          if (attr.hasChildNodes()) {
            value = attr.getFirstChild().getNodeValue();
            break;
          }
        }
      }
      result.put(key,value);
    }
    return result;
  }
}
